Index: src/Descriptors/MoleculeDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/MoleculeDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,174 @@
+/*
+ * MoleculeDescriptor.cpp
+ *
+ *  Created on: Feb 5, 2010
+ *      Author: crueger
+ */
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "Descriptors/MoleculeDescriptor_impl.hpp"
+
+#include "World.hpp"
+
+#include "molecule.hpp"
+
+#include <boost/bind.hpp>
+#include <cassert>
+#include <iostream>
+
+using namespace std;
+
+typedef World::MoleculeSet::iterator molecules_iter_t;
+
+/************************ Forwarding object **************************************/
+
+
+MoleculeDescriptor::MoleculeDescriptor(impl_ptr _impl) :
+    impl(_impl)
+{}
+
+MoleculeDescriptor::MoleculeDescriptor(const MoleculeDescriptor& src) :
+    impl(src.get_impl())
+{}
+
+MoleculeDescriptor::~MoleculeDescriptor()
+{}
+
+MoleculeDescriptor& MoleculeDescriptor::operator=(MoleculeDescriptor &src){
+  if(&src!=this) {
+    impl=src.get_impl();
+  }
+  return *this;
+}
+
+molecule* MoleculeDescriptor::find(){
+  return impl->find();
+}
+
+std::vector<molecule*> MoleculeDescriptor::findAll(){
+  return impl->findAll();
+}
+
+MoleculeDescriptor::impl_ptr MoleculeDescriptor::get_impl() const{
+  return impl;
+}
+
+
+
+
+/**************************** implementation ********************/
+
+MoleculeDescriptor_impl::MoleculeDescriptor_impl()
+{
+}
+
+MoleculeDescriptor_impl::~MoleculeDescriptor_impl()
+{
+}
+
+World::MoleculeSet& MoleculeDescriptor_impl::getMolecules(){
+  return World::getInstance().molecules;
+}
+
+molecule* MoleculeDescriptor_impl::find() {
+  World::MoleculeSet molecules = getMolecules();
+  molecules_iter_t res = find_if(molecules.begin(),molecules.end(),boost::bind(&MoleculeDescriptor_impl::predicate,this,_1));
+  return (res!=molecules.end())?((*res).second):0;
+}
+
+vector<molecule*> MoleculeDescriptor_impl::findAll() {
+  vector<molecule*> res;
+  World::MoleculeSet molecules = getMolecules();
+  molecules_iter_t iter;
+  for(iter=molecules.begin();iter!=molecules.end();++iter) {
+    if(predicate(*iter)){
+      res.push_back((*iter).second);
+    }
+  }
+  return res;
+}
+
+/************************** Universe and Emptyset *****************/
+
+MoleculeAllDescriptor_impl::MoleculeAllDescriptor_impl()
+{}
+
+MoleculeAllDescriptor_impl::~MoleculeAllDescriptor_impl()
+{}
+
+bool MoleculeAllDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*>){
+  return true;
+}
+
+MoleculeDescriptor AllMolecules(){
+  return MoleculeDescriptor(MoleculeDescriptor::impl_ptr(new MoleculeAllDescriptor_impl));
+}
+
+MoleculeNoneDescriptor_impl::MoleculeNoneDescriptor_impl()
+{}
+
+MoleculeNoneDescriptor_impl::~MoleculeNoneDescriptor_impl()
+{}
+
+bool MoleculeNoneDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*>){
+  return false;
+}
+
+MoleculeDescriptor NoMolecules(){
+  return MoleculeDescriptor(MoleculeDescriptor::impl_ptr(new MoleculeNoneDescriptor_impl));
+}
+
+/************************** Operator stuff ************************/
+
+// AND
+MoleculeAndDescriptor_impl::MoleculeAndDescriptor_impl(MoleculeDescriptor::impl_ptr _lhs, MoleculeDescriptor::impl_ptr _rhs) :
+    lhs(_lhs), rhs(_rhs)
+{}
+
+MoleculeAndDescriptor_impl::~MoleculeAndDescriptor_impl()
+{}
+
+bool MoleculeAndDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule){
+  return lhs->predicate(molecule) && rhs->predicate(molecule);
+}
+MoleculeDescriptor operator&&(const MoleculeDescriptor &lhs, const MoleculeDescriptor &rhs){
+  MoleculeDescriptor::impl_ptr newImpl = MoleculeDescriptor::impl_ptr(new MoleculeAndDescriptor_impl(lhs.get_impl(),rhs.get_impl()));
+  return MoleculeDescriptor(newImpl);
+}
+
+// OR
+MoleculeOrDescriptor_impl::MoleculeOrDescriptor_impl(MoleculeDescriptor::impl_ptr _lhs ,MoleculeDescriptor::impl_ptr _rhs) :
+    lhs(_lhs), rhs(_rhs)
+{}
+
+MoleculeOrDescriptor_impl::~MoleculeOrDescriptor_impl(){
+}
+
+bool MoleculeOrDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule){
+  return lhs->predicate(molecule) || rhs->predicate(molecule);
+}
+
+MoleculeDescriptor  operator||(const MoleculeDescriptor &lhs, const MoleculeDescriptor &rhs){
+  MoleculeDescriptor::impl_ptr newImpl = MoleculeDescriptor::impl_ptr(new MoleculeOrDescriptor_impl(lhs.get_impl(),rhs.get_impl()));
+  return MoleculeDescriptor(newImpl);
+}
+
+// NOT
+
+MoleculeNotDescriptor_impl::MoleculeNotDescriptor_impl(MoleculeDescriptor::impl_ptr _arg) :
+    arg(_arg)
+{}
+
+
+MoleculeNotDescriptor_impl::~MoleculeNotDescriptor_impl()
+{
+}
+
+bool MoleculeNotDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule){
+ return !(arg->predicate(molecule));
+}
+
+MoleculeDescriptor operator!(const MoleculeDescriptor &arg){
+  MoleculeDescriptor::impl_ptr newImpl = MoleculeDescriptor::impl_ptr(new MoleculeNotDescriptor_impl(arg.get_impl()));
+  return MoleculeDescriptor(newImpl);
+}
Index: src/Descriptors/MoleculeDescriptor.hpp
===================================================================
--- src/Descriptors/MoleculeDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/MoleculeDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,115 @@
+/*
+ * MoleculeDescriptor.hpp
+ *
+ *  Created on: Feb 5, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULEDESCRIPTOR_HPP_
+#define MOLECULEDESCRIPTOR_HPP_
+
+
+#include <vector>
+#include <map>
+#include <boost/shared_ptr.hpp>
+#include "World.hpp"
+
+class World;
+class molecule;
+
+// internal implementation, allows assignment, copying etc
+class MoleculeDescriptor_impl;
+
+/**
+ * An MoleculeDescriptor describes a Set of Molecules from the World. Can be used for any method that needs to work on
+ * a specific set of Molecules.
+ *
+ * This Class is implemented using the PIMPL-Idion, i.e. this class only contains an abstract structure
+ * that forwards any request to a wrapped pointer-to-implementation. This way operators and calculations
+ * on Descriptors are possible.
+ *
+ * Concrete Implementation Objects can be shared between multiple Wrappers, so make sure that
+ * any Implementation remainst constant during lifetime.
+ */
+class MoleculeDescriptor {
+  // close coupling to the world to allow access
+  friend molecule* World::getMolecule(MoleculeDescriptor descriptor);
+  friend std::vector<molecule*> World::getAllMolecules(MoleculeDescriptor descriptor);
+  template <class,class,class> friend class SelectiveIterator;
+
+  friend MoleculeDescriptor operator&&(const MoleculeDescriptor &lhs, const MoleculeDescriptor &rhs);
+  friend MoleculeDescriptor operator||(const MoleculeDescriptor &lhs, const MoleculeDescriptor &rhs);
+  friend MoleculeDescriptor operator!(const MoleculeDescriptor &arg);
+
+public:
+  typedef MoleculeDescriptor_impl impl_t;
+  typedef boost::shared_ptr<impl_t> impl_ptr; //!< Allow easy changes of the pointer-to-implementation type
+
+  MoleculeDescriptor(impl_ptr);
+
+  /**
+   * Copy constructor.
+   * Takes the Implementation from the copied object and sets it's own pointer to link there.
+   * This way the actuall implementation object is shared between copy and original
+   */
+  MoleculeDescriptor(const MoleculeDescriptor&);
+  ~MoleculeDescriptor();
+
+  /**
+   * Assignment Operator.
+   *
+   * Implemented by setting the pointer to the new Implementation.
+   */
+  MoleculeDescriptor &operator=(MoleculeDescriptor &);
+
+protected:
+  /**
+   * forward Method to implementation
+   */
+  molecule* find();
+
+  /**
+   * forward Method to implementation
+   */
+  std::vector<molecule*> findAll();
+
+  /**
+   * Return the implementation this Wrapper currently points to.
+   * Used for copying, assignment and in Iterators over subsets of the World.
+   */
+  impl_ptr get_impl() const;
+
+private:
+  impl_ptr impl;
+};
+
+/**
+ * produce an Moleculedescriptor that at the point of construction contains an implementation that matches all Molecules
+ */
+MoleculeDescriptor AllMolecules();
+
+/**
+ * produce an Moleculedescriptor that at the point of construction contains an implementation that matches no Molecules
+ */
+MoleculeDescriptor NoMolecules();
+
+/**
+ * Set Intersection for two Moleculedescriptors. The resulting Moleculedescriptor will only match an Molecule if both
+ * given Moleculedescriptors also match. Uses short circuit inside, so the second predicate wont be called
+ * when the first one failed.
+ */
+MoleculeDescriptor operator&&(const MoleculeDescriptor &lhs, const MoleculeDescriptor &rhs);
+
+/**
+ * Set Union for two MoleculeDescriptors. The resulting MoleculeDescriptor will match an Molecule if at least one of
+ * the two given MoleculeDescriptors does match. Used short circuit inside, so the second predicate wont
+ * be called when the first one failed.
+ */
+MoleculeDescriptor operator||(const MoleculeDescriptor &lhs, const MoleculeDescriptor &rhs);
+
+/**
+ * Set inversion for an MoleculeDescriptor. Matches an Molecule if the given MoleculeDescriptor did not match.
+ */
+MoleculeDescriptor operator!(const MoleculeDescriptor &arg);
+
+#endif /* MOLECULEDESCRIPTOR_HPP_ */
Index: src/Descriptors/MoleculeDescriptor_impl.hpp
===================================================================
--- src/Descriptors/MoleculeDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/MoleculeDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,145 @@
+#ifndef MOLECULEDESCRIPTOR_IMPL_HPP
+#define MOLECULEDESCRIPTOR_IMPL_HPP
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+
+/************************ Declarations of implementation Objects ************************/
+
+/**
+ * This class implements a general Base class for MoleculeDescriptors using the PIMPL-Idiom
+ *
+ * The predicate for this class is empty and should be implemented by derived classes.
+ * By the predicate it is described which molecules should be picked for a given descriptor.
+ */
+
+class MoleculeDescriptor_impl
+{
+  friend class MoleculeDescriptor;
+public:
+
+  MoleculeDescriptor_impl();
+  virtual ~MoleculeDescriptor_impl();
+
+  /**
+   * Implement this abstract Method to make a concrete MoleculeDescriptor pick certain Molecules
+   */
+  virtual bool predicate(std::pair<moleculeId_t,molecule*>)=0;
+
+protected:
+
+  /**
+   * This method is called when the Descriptor is used to find the first matching
+   * Molecule. Walks through all Molecules and stops on the first match. Can be implemented
+   * when the searched Molecule can be found in a more efficient way. Calculated
+   * Moleculedescriptors will always use this method, so no improvement there.
+   */
+  virtual molecule* find();
+
+  /**
+   * This method is called when the Descriptor is used to find all matching Molecules.
+   * Walks through all Molecules and tests the predicate on each one. A vector of all
+   * matching Molecules is returned.
+   */
+  virtual std::vector<molecule*> findAll();
+
+  /**
+   * This method is used internally to query the Set of Molecules from the world.
+   * By using this method derived classes can also access the Internal World Datastructre.
+   * Implemented in full in the Base Descriptor Implementation, so only this one method
+   * needs to be friend with the World class.
+   */
+  World::MoleculeSet& getMolecules();
+};
+
+/************************** Universe and Emptyset *****************/
+
+/**
+ * A simple MoleculeDescriptor that will always match all Molecules present in the World.
+ */
+class MoleculeAllDescriptor_impl : public MoleculeDescriptor_impl {
+public:
+  MoleculeAllDescriptor_impl();
+  virtual ~MoleculeAllDescriptor_impl();
+
+  /**
+   * Always returns true for any Molecule
+   */
+  virtual bool predicate(std::pair<moleculeId_t,molecule*>);
+};
+
+
+/**
+ * An MoleculeDescriptor that never matches any Molecule in the World.
+ */
+class MoleculeNoneDescriptor_impl : public MoleculeDescriptor_impl {
+public:
+  MoleculeNoneDescriptor_impl();
+  virtual ~MoleculeNoneDescriptor_impl();
+
+  /**
+   * Always returns false for any Molecule
+   */
+  virtual bool predicate(std::pair<moleculeId_t,molecule*>);
+};
+
+/************************** Operator stuff ************************/
+
+/**
+ * Intersection of two MoleculeDescriptors
+ */
+class MoleculeAndDescriptor_impl : public MoleculeDescriptor_impl
+{
+public:
+  MoleculeAndDescriptor_impl(MoleculeDescriptor::impl_ptr _lhs, MoleculeDescriptor::impl_ptr _rhs);
+  ~MoleculeAndDescriptor_impl();
+
+  /**
+   * This predicate uses the predicate from the first && the predicate from the
+   * second Descriptor to decide if an Molecule should be selected.
+   */
+  virtual bool predicate(std::pair<moleculeId_t,molecule*>);
+
+private:
+  MoleculeDescriptor::impl_ptr lhs;
+  MoleculeDescriptor::impl_ptr rhs;
+};
+
+/**
+ * Union of two MoleculeDescriptors
+ */
+class MoleculeOrDescriptor_impl : public MoleculeDescriptor_impl
+{
+public:
+  MoleculeOrDescriptor_impl(MoleculeDescriptor::impl_ptr _lhs, MoleculeDescriptor::impl_ptr _rhs);
+  virtual ~MoleculeOrDescriptor_impl();
+
+  /**
+   * This predicate uses the predicate form the first || the predicate from the
+   * second Descriptor to decide if an Molecule should be selected.
+   */
+  virtual bool predicate(std::pair<moleculeId_t,molecule*>);
+
+private:
+  MoleculeDescriptor::impl_ptr lhs;
+  MoleculeDescriptor::impl_ptr rhs;
+};
+
+/**
+ * Set Inversion of a Descriptor
+ */
+class MoleculeNotDescriptor_impl : public MoleculeDescriptor_impl
+{
+public:
+  MoleculeNotDescriptor_impl(MoleculeDescriptor::impl_ptr _arg);
+  virtual ~MoleculeNotDescriptor_impl();
+
+  /**
+   * Opposite of the given descriptor predicate.
+   */
+  virtual bool predicate(std::pair<moleculeId_t,molecule*>);
+
+private:
+  MoleculeDescriptor::impl_ptr arg;
+};
+
+#endif //MOLECULEDESCRIPTOR_IMPL_HPP
Index: src/Descriptors/MoleculeIdDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeIdDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/MoleculeIdDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,40 @@
+/*
+ * MoleculeIdDescriptor.cpp
+ *
+ *  Created on: Feb 5, 2010
+ *      Author: crueger
+ */
+
+#include "MoleculeIdDescriptor.hpp"
+#include "MoleculeIdDescriptor_impl.hpp"
+
+#include "molecule.hpp"
+
+using namespace std;
+
+
+MoleculeIdDescriptor_impl::MoleculeIdDescriptor_impl(moleculeId_t _id) :
+  id(_id)
+{}
+
+MoleculeIdDescriptor_impl::~MoleculeIdDescriptor_impl()
+{}
+
+bool MoleculeIdDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule) {
+  return molecule.first==id;
+}
+
+MoleculeDescriptor MoleculeById(moleculeId_t id){
+  return MoleculeDescriptor(MoleculeDescriptor::impl_ptr(new MoleculeIdDescriptor_impl(id)));
+}
+
+molecule *MoleculeIdDescriptor_impl::find(){
+  World::MoleculeSet molecules = getMolecules();
+  World::MoleculeSet::iterator res = molecules.find(id);
+  return (res!=molecules.end())?((*res).second):0;
+}
+
+vector<molecule*> MoleculeIdDescriptor_impl::findAll(){
+  molecule *res = find();
+  return (res)?(vector<molecule*>(1,res)):(vector<molecule*>());
+}
Index: src/Descriptors/MoleculeIdDescriptor.hpp
===================================================================
--- src/Descriptors/MoleculeIdDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/MoleculeIdDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,16 @@
+/*
+ * MoleculeIdDescriptor.hpp
+ *
+ *  Created on: Feb 5, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULEIDDESCRIPTOR_HPP_
+#define MOLECULEIDDESCRIPTOR_HPP_
+
+#include "defs.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+
+MoleculeDescriptor MoleculeById(moleculeId_t id);
+
+#endif /* MOLECULEIDDESCRIPTOR_HPP_ */
Index: src/Descriptors/MoleculeIdDescriptor_impl.hpp
===================================================================
--- src/Descriptors/MoleculeIdDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/MoleculeIdDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,21 @@
+#ifndef MOLECULEIDDESCRIPTOR_IMPL_HPP
+#define MOLECULEIDDESCRIPTOR_IMPL_HPP
+
+#include "Descriptors/MoleculeDescriptor_impl.hpp"
+
+class MoleculeIdDescriptor_impl : public MoleculeDescriptor_impl
+{
+public:
+  MoleculeIdDescriptor_impl(moleculeId_t _id);
+  virtual ~MoleculeIdDescriptor_impl();
+
+  bool predicate(std::pair<moleculeId_t,molecule*> molecule);
+
+protected:
+  virtual molecule *find();
+  virtual std::vector<molecule*> findAll();
+private:
+  moleculeId_t id;
+};
+
+#endif //MOLECULEIDDESCRIPTOR_IMPL_HPP
Index: src/Descriptors/SelectiveIterator.hpp
===================================================================
--- src/Descriptors/SelectiveIterator.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/SelectiveIterator.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,52 @@
+/*
+ * SelectiveIterator.hpp
+ *
+ *  Created on: Mar 17, 2010
+ *      Author: crueger
+ */
+
+#ifndef SELECTIVEITERATOR_HPP_
+#define SELECTIVEITERATOR_HPP_
+
+#include <iterator>
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+class SelectiveIterator :
+  public std::iterator<typename std::iterator_traits<typename _Container::iterator>::difference_type,
+                       typename std::iterator_traits<typename _Container::iterator>::value_type,
+                       typename std::iterator_traits<typename _Container::iterator>::pointer,
+                       typename std::iterator_traits<typename _Container::iterator>::reference>
+{
+public:
+  typedef typename _Container::iterator     Iter;
+  typedef          _Target                  Target;
+  typedef typename Iter::value_type         value_type;
+  typedef typename Iter::difference_type    difference_type;
+  typedef typename Iter::pointer            pointer;
+  typedef typename Iter::reference          reference;
+  typedef typename Iter::iterator_category  iterator_category;
+
+
+  SelectiveIterator(_Descriptor, _Container&);
+  SelectiveIterator(_Descriptor, _Container&, Iter);
+  SelectiveIterator(const SelectiveIterator&);
+  SelectiveIterator& operator=(const SelectiveIterator&);
+  SelectiveIterator& operator++();     // prefix
+  SelectiveIterator  operator++(int);  // postfix with dummy parameter
+  bool operator==(const SelectiveIterator&);
+  bool operator!=(const SelectiveIterator&);
+  Target operator*();
+
+  int getCount();
+protected:
+  void advanceState();
+  Iter state;
+  typename _Descriptor::impl_ptr descr;
+  int index;
+
+  _Container &content;
+};
+
+#endif /* SELECTIVEITERATOR_HPP_ */
Index: src/Descriptors/SelectiveIterator_impl.hpp
===================================================================
--- src/Descriptors/SelectiveIterator_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/SelectiveIterator_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,137 @@
+/*
+ * SelectiveIterator_impl.hpp
+ *
+ *  Created on: Mar 17, 2010
+ *      Author: crueger
+ */
+
+#ifndef SELECTIVEITERATOR_IMPL_HPP_
+#define SELECTIVEITERATOR_IMPL_HPP_
+
+#include "helpers.hpp"
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+SelectiveIterator<_Target,_Container,_Descriptor>::SelectiveIterator(_Descriptor _descr, _Container &_content) :
+    descr(_descr.get_impl()),
+    index(0),
+    content(_content)
+{
+  state = content.begin();
+  advanceState();
+}
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+SelectiveIterator<_Target,_Container,_Descriptor>::SelectiveIterator(_Descriptor _descr, _Container &_content, SelectiveIterator<_Target,_Container,_Descriptor>::Iter _state) :
+    state(_state),
+    descr(_descr.get_impl()),
+    index(0),
+    content(_content)
+{
+  advanceState();
+}
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+SelectiveIterator<_Target,_Container,_Descriptor>::SelectiveIterator(const SelectiveIterator<_Target,_Container,_Descriptor>& rhs) :
+    state(rhs.state),
+    descr(rhs.descr),
+    index(rhs.index),
+    content(rhs.content)
+  {}
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+SelectiveIterator<_Target,_Container,_Descriptor>& SelectiveIterator<_Target,_Container,_Descriptor>::operator=(const SelectiveIterator<_Target,_Container,_Descriptor>& rhs)
+{
+  if(&rhs!=this){
+    state=rhs.state;
+    descr=rhs.descr;
+    index=rhs.index;
+  }
+  return *this;
+}
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+SelectiveIterator<_Target,_Container,_Descriptor>&
+  SelectiveIterator<_Target,_Container,_Descriptor>::operator++(){
+    ++state;
+    ++index;
+    advanceState();
+    return *this;
+  }
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+SelectiveIterator<_Target,_Container,_Descriptor> SelectiveIterator<_Target,_Container,_Descriptor>::operator++(int){
+    SelectiveIterator<_Target,_Container,_Descriptor> res = SelectiveIterator<_Target,_Container,_Descriptor>(*this);
+    ++(*this);
+    return res;
+  }
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+bool
+  SelectiveIterator<_Target,_Container,_Descriptor>::operator==(const SelectiveIterator<_Target,_Container,_Descriptor>& rhs){
+    return state==rhs.state;
+  }
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+bool
+  SelectiveIterator<_Target,_Container,_Descriptor>::operator!=(const SelectiveIterator<_Target,_Container,_Descriptor>& rhs){
+    return state!=rhs.state;
+  }
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+typename SelectiveIterator<_Target,_Container,_Descriptor>::Target
+  SelectiveIterator<_Target,_Container,_Descriptor>::operator*(){
+    return _take<_Target,value_type>::get(*state);
+  }
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+void
+  SelectiveIterator<_Target,_Container,_Descriptor>::advanceState(){
+    // go forward until we have a matching atom or the end is reached
+    while((state!=content.end()) && (!descr->predicate(*state))){
+      ++state;
+      ++index;
+    }
+  }
+
+template<class _Target,
+         class _Container,
+         class _Descriptor>
+int
+  SelectiveIterator<_Target,_Container,_Descriptor>::getCount(){
+    return index;
+  }
+
+
+#define CONSTRUCT_SELECTIVE_ITERATOR(_Target,_Container,_Descriptor) \
+		template SelectiveIterator<_Target,_Container,_Descriptor>::SelectiveIterator(_Descriptor, _Container&); \
+		template SelectiveIterator<_Target,_Container,_Descriptor>::SelectiveIterator(_Descriptor, _Container&, SelectiveIterator<_Target,_Container,_Descriptor>::Iter); \
+    template SelectiveIterator<_Target,_Container,_Descriptor>::SelectiveIterator(const SelectiveIterator<_Target,_Container,_Descriptor>&); \
+    template SelectiveIterator<_Target,_Container,_Descriptor>& SelectiveIterator<_Target,_Container,_Descriptor>::operator=(const SelectiveIterator<_Target,_Container,_Descriptor>&); \
+    template SelectiveIterator<_Target,_Container,_Descriptor>& SelectiveIterator<_Target,_Container,_Descriptor>::operator++(); \
+    template SelectiveIterator<_Target,_Container,_Descriptor> SelectiveIterator<_Target,_Container,_Descriptor>::operator++(int); \
+    template bool SelectiveIterator<_Target,_Container,_Descriptor>::operator==(const SelectiveIterator<_Target,_Container,_Descriptor>&); \
+    template bool SelectiveIterator<_Target,_Container,_Descriptor>::operator!=(const SelectiveIterator<_Target,_Container,_Descriptor>&); \
+    template SelectiveIterator<_Target,_Container,_Descriptor>::Target SelectiveIterator<_Target,_Container,_Descriptor>::operator*(); \
+    template int SelectiveIterator<_Target,_Container,_Descriptor>::getCount();
+
+#endif /* SELECTIVEITERATOR_IMPL_HPP_ */
Index: src/Exceptions/CustomException.cpp
===================================================================
--- src/Exceptions/CustomException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/CustomException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,25 @@
+/*
+ * CustomException.cpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#include "CustomException.hpp"
+
+using namespace std;
+
+CustomException::CustomException(std::string _file, int _line):
+ file(_file),
+ line(_line)
+{}
+
+CustomException::~CustomException() throw ()
+{}
+
+
+ostream& operator<<(ostream &ost,CustomException &excp){
+  // we use this to let others know from where the exception was thrown
+  ost << excp.what() << "\nIn " << excp.file << ":" << excp.line;
+  return ost;
+}
Index: src/Exceptions/CustomException.hpp
===================================================================
--- src/Exceptions/CustomException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/CustomException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,32 @@
+/*
+ * CustomException.hpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef CUSTOMEXCEPTION_HPP_
+#define CUSTOMEXCEPTION_HPP_
+
+#include <exception>
+#include <iostream>
+
+/**
+ * Custom Exceptions are simply a bit more verbose versions of the
+ * std::exceptions.
+ */
+class CustomException : public std::exception
+{
+  friend std::ostream& operator<<(std::ostream &ost, CustomException &excp);
+public:
+  CustomException(std::string file, int line);
+  virtual ~CustomException() throw();
+
+private:
+  std::string file;
+  int line;
+};
+
+std::ostream& operator<<(std::ostream &ost, CustomException &excp);
+
+#endif /* CUSTOMEXCEPTION_HPP_ */
Index: src/Exceptions/LinearDependenceException.cpp
===================================================================
--- src/Exceptions/LinearDependenceException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/LinearDependenceException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,22 @@
+/*
+ * LinearDependenceException.cpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#include "LinearDependenceException.hpp"
+
+using namespace std;
+
+LinearDependenceException::LinearDependenceException(string _file, int _line) :
+  MathException(_file,_line)
+{}
+
+LinearDependenceException::~LinearDependenceException() throw ()
+{}
+
+const char* LinearDependenceException::what() const throw()
+{
+  return "Given vectors are linear dependent.";
+}
Index: src/Exceptions/LinearDependenceException.hpp
===================================================================
--- src/Exceptions/LinearDependenceException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/LinearDependenceException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,22 @@
+/*
+ * LinearDependenceException.hpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef LINEARDEPENDENCEEXCEPTION_HPP_
+#define LINEARDEPENDENCEEXCEPTION_HPP_
+
+#include "Exceptions/MathException.hpp"
+
+class LinearDependenceException : public MathException
+{
+public:
+  LinearDependenceException(std::string _file, int _line);
+  virtual ~LinearDependenceException() throw ();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* LINEARDEPENDENCEEXCEPTION_HPP_ */
Index: src/Exceptions/MathException.cpp
===================================================================
--- src/Exceptions/MathException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/MathException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,15 @@
+/*
+ * MathException.cpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#include "MathException.hpp"
+
+MathException::MathException(std::string file, int line) :
+  CustomException(file,line)
+{}
+
+MathException::~MathException() throw ()
+{}
Index: src/Exceptions/MathException.hpp
===================================================================
--- src/Exceptions/MathException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/MathException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,20 @@
+/*
+ * MathException.hpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef MATHEXCEPTION_HPP_
+#define MATHEXCEPTION_HPP_
+
+#include "Exceptions/CustomException.hpp"
+
+class MathException : public CustomException
+{
+public:
+  MathException(std::string file, int line);
+  virtual ~MathException() throw();
+};
+
+#endif /* MATHEXCEPTION_HPP_ */
Index: src/Exceptions/ZeroVectorException.cpp
===================================================================
--- src/Exceptions/ZeroVectorException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/ZeroVectorException.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,20 @@
+/*
+ * ZeroVectorException.cpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#include "ZeroVectorException.hpp"
+
+ZeroVectorException::ZeroVectorException(std::string file, int line) :
+  MathException(file,line)
+{}
+
+ZeroVectorException::~ZeroVectorException() throw ()
+{}
+
+const char* ZeroVectorException::what() const throw()
+{
+  return "Given vector was a zero Vector.";
+}
Index: src/Exceptions/ZeroVectorException.hpp
===================================================================
--- src/Exceptions/ZeroVectorException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Exceptions/ZeroVectorException.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,22 @@
+/*
+ * ZeroVectorException.hpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef ZEROVECTOREXCEPTION_HPP_
+#define ZEROVECTOREXCEPTION_HPP_
+
+#include "Exceptions/MathException.hpp"
+
+class ZeroVectorException : public MathException
+{
+public:
+  ZeroVectorException(std::string file, int line);
+  virtual ~ZeroVectorException() throw();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* ZEROVECTOREXCEPTION_HPP_ */
